//We need an import statement to use Java's LinkedList
//or we would need to use our own.
//Besides, why should every programmer have to write their
//own linked list implementation ??!?
import java.util.LinkedList;
 public class FifoQueue{
   LinkedList<String> q;
   //What's the deal with those angle brackets?
   //Well, that specified the typE of data to use, instead
   //of Object!
   FifoQueue(){
       //as per usual, use the constructor to allocate
       //memory by calling the LinkedList constructor.
       q = new LinkedList<String>(); 
   }
   
   void enqueue(String name){ 
       q.add(name); 
   }

   String dequeue(){
     //String rval = q.size() > 0 ? q.remove(0) : null;  
     //Same as above...
     String rval;
     if (q.size() > 0)
        rval = q.remove(0);
     else
        rval = null;
     return rval;
   }
   /* * * * * * * * * * * * * * * * * * * * * * * * * * */
   /*                                                   */
   /* We can simply use the fifo queue that we defined  */
   /*                                                   */
   /* * * * * * * * * * * * * * * * * * * * * * * * * * */
   public static void main(String[] args){
    FifoQueue fifo = new FifoQueue();
    fifo.enqueue("Dr. Fauci"); 
    fifo.enqueue("House, MD");
    fifo.enqueue("Dr. Osterholm");
    fifo.enqueue("Dr. Brix");
                
    for (String name = fifo.dequeue(); name != null; name = fifo.dequeue()) {
      System.out.printf("Step up to the podium, %s!\n", name);
    }
  }

 }